SystemOrganization addCategory: #ConfigurationOfPier3!

Object subclass: #ConfigurationOfPier3
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfPier3'!

!ConfigurationOfPier3 class methodsFor: 'private' stamp: 'NickAger 1/30/2012 15:04'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfPier3 class methodsFor: 'private' stamp: 'NickAger 1/30/2012 15:04'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfPier3 class methodsFor: 'metacello tool support' stamp: 'NickAger 1/30/2012 15:04'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPier3 class methodsFor: 'loading' stamp: 'NickAger 2/1/2012 18:14'!
load
	"self load"
	
	self project stableVersion load! !

!ConfigurationOfPier3 class methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 15:04'!
project

	^self new project! !

!ConfigurationOfPier3 class methodsFor: 'release' stamp: 'NickAger 1/30/2012 15:04'!
releaseToGemSource
	"self releaseToGemSource"

	(Smalltalk at: #Gofer) new
		gemsource: 'MetacelloRepository';
		package: self name asString;
		push! !

!ConfigurationOfPier3 class methodsFor: 'release' stamp: 'NickAger 1/30/2012 15:04'!
releaseToSqueakSource
	"self releaseToSqueakSource"

	(Smalltalk at: #Gofer) new
		squeaksource: 'MetacelloRepository';
		package: self name asString;
		push! !

!ConfigurationOfPier3 methodsFor: 'baselines' stamp: 'NickAger 2/22/2012 18:43'!
baseline300: spec 
	<version: '3.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://source.lukas-renggli.ch/pier3'.
		spec
			project: 'Javascript' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #stable;
					loads: #( 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-UI' );
					file: 'ConfigurationOfSeaside30';
					repository: 'http://www.squeaksource.com/MetacelloRepository'];
			project: 'Magritte3 Core' with: [
				spec
					className: 'ConfigurationOfMagritte3';
					versionString: #stable;
					loads: #('Core');
					file: 'ConfigurationOfMagritte3';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Magritte3 Tests' copyFrom: 'Magritte3 Core' with: [
				spec
					loads: #( 'Tests' ).];
			project: 'Magritte3 Seaside' copyFrom: 'Magritte3 Core' with: [
				spec
					loads: #( 'Seaside' ).];
			yourself.
		spec 
			package: 'Pier-Model' with: [ spec requires: #('Magritte3 Core')];
			package: 'Pier-Tests-Model' with: [ spec requires: #('Pier-Model' 'Magritte3 Tests')];
			package: 'Pier-Security' with: [ spec requires: #('Pier-Seaside')];
			package: 'Pier-Seaside' with: [ spec requires: #('Pier-Model' 'Magritte3 Seaside' 'Javascript')];
			package: 'Pier-Tests-Security' with: [ spec requires: #('Pier-Security')];
			yourself.
		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #('Pier-Model' 'Pier-Security' 'Pier-Seaside' );
			group: 'Tests' with: #('Core' 'Pier-Tests-Model' 'Pier-Tests-Security' );
			yourself ].
		
	spec for: #squeakCommon do: [
		spec
			package: 'Pier-Model' with: [ spec includes: #('Pier-Pharo-Model')];
			package: 'Pier-Seaside' with: [ spec includes: #('Pier-Pharo-Seaside')];

			package: 'Pier-Pharo-Model' with: [ spec requires: #('Pier-Model')];
			package: 'Pier-Pharo-Seaside' with: [ spec requires: #('Pier-Seaside')];
			
			package: 'Pier-Pharo-Persistency' with: [ spec requires: #('Pier-Model') ];
			package: 'Pier-Tests-Pharo-Persistency' with: [ 
				spec requires: #('Pier-Tests-Model' 'Pier-Pharo-Persistency')];
			yourself.
		spec
			group: 'Core' with: #('Pier-Pharo-Persistency' );
			group: 'Tests' with: #('Pier-Tests-Pharo-Persistency');
			yourself ].
		
	spec for: #gemstone do: [
		spec
			package: 'Pier-Model' with: [ spec includes: #('Pier-GemStone-Model')];
			package: 'Pier-Seaside' with: [ spec includes: #('Pier-GemStone-Seaside')];

			package: 'Pier-GemStone-Model' with: [ spec requires: #('Pier-Model')];
			package: 'Pier-GemStone-Seaside' with: [ spec requires: #('Pier-Seaside')];
			yourself ].! !

!ConfigurationOfPier3 methodsFor: 'symbolic versions' stamp: 'NickAger 1/30/2012 15:04'!
development: spec 
	"no development versions at the moment"
	
	<symbolicVersion: #development>
! !

!ConfigurationOfPier3 methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 15:04'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear ]! !

!ConfigurationOfPier3 methodsFor: 'symbolic versions' stamp: 'NickAger 1/30/2012 15:17'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'common' version: '3.0.0'. 
! !

!ConfigurationOfPier3 methodsFor: 'versions' stamp: 'NickAger 2/24/2012 15:38'!
version300: spec
	<version: '3.0.0' imports: #('3.0-baseline' )>

	spec for: #common do: [
		spec blessing: #release.
		spec description: 'Pier on Seaside 3.0 with Magritte 3 (magritte with instance-side pragma descriptions)'.
		spec author: 'NickAger'.
		spec timestamp: '01/30/2012 15:15'.
		spec 
			project: 'Javascript' with: #stable;
			project: 'Magritte3 Core' with: #stable;
			project: 'Magritte3 Tests' with: #stable;
			project: 'Magritte3 Seaside' with: #stable.
		spec 
			package: 'Pier-Model' with: 'Pier-Model-NickAger.424';
			package: 'Pier-Seaside' with: 'Pier-Seaside-NickAger.535';
			package: 'Pier-Tests-Model' with: 'Pier-Tests-Model-NickAger.29';
			package: 'Pier-Security' with: 'Pier-Security-NickAger.184';
			package: 'Pier-Tests-Security' with: 'Pier-Tests-Security-NickAger.13' ].
		
	spec for: #squeakCommon do: [
		spec 
			package: 'Pier-Pharo-Model' with: 'Pier-Pharo-Model-NickAger.4';
			package: 'Pier-Pharo-Persistency' with: 'Pier-Pharo-Persistency-NickAger.21';
			package: 'Pier-Pharo-Seaside' with: 'Pier-Pharo-Seaside-lr.5';
			package: 'Pier-Tests-Pharo-Persistency' with: 'Pier-Tests-Pharo-Persistency-YanniChiu.1'.].
		
	spec for: #gemstone do: [
		spec 
			package: 'Pier-GemStone-Model' with: 'Pier-GemStone-Model-NickAger.4';
			package: 'Pier-GemStone-Seaside' with: 'Pier-GemStone-Seaside-DaleHenrichs.1'.].! !
